#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

// Uniforms
uniform sampler2D u_texture;
uniform float u_time;
uniform vec3 u_resolution;

// Varyings
varying vec2 v_texCoord;

void main()
{
	vec4 strength = -1.0 * 0.5 * vec4(0.9, 1.0, 1.3, 1.0);
	vec2 uv = gl_FragCoord.xy / u_resolution.xy;

	vec2 p = (uv - 0.5) * 2.0; // map [0, 1] to [-1, 1]
	float theta = atan(p.y, p.x);
	float rd = length(p);
	vec4 ru = rd * (1.0 + strength * rd * rd) / vec4(1.0);
	vec2 dir = vec2(cos(theta), sin(theta)); 
	vec2 qr = dir * ru.x / 2.0 + 0.5;
	vec2 qg = dir * ru.y / 2.0 + 0.5;
	vec2 qb = dir * ru.z / 2.0 + 0.5;
	vec2 qa = dir * ru.w / 2.0 + 0.5;

	gl_FragColor = vec4(
		texture2D(u_texture, qr).x,
		texture2D(u_texture, qg).y,
		texture2D(u_texture, qb).z,
		texture2D(u_texture, qa).w);
}
