// ̃VF[_[͉LQlɂĂ܂
// https://qiita.com/saragai/items/2885d83f55a46f206d1d
#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

// Uniforms
uniform sampler2D u_texture;
uniform vec3 u_resolution;

// Varyings
varying vec2 v_texCoord;

// ʂoĂ悤ɂ䂪܂
vec2 distort(vec2 uv, float rate)
{
	uv -= 0.5;
	uv /= 1.0 - length(uv) * rate;
	uv += 0.5;
	return uv;
}

// 3x3̃KEVAtB^
vec4 gaussian_sample(vec2 uv, vec2 dx, vec2 dy)
{
	vec4 col = vec4(0.0);
	col += texture2D(u_texture, uv - dx - dy) * 1.0 / 16.0;
	col += texture2D(u_texture, uv - dx) * 2.0 / 16.0;
	col += texture2D(u_texture, uv - dx + dy) * 1.0 / 16.0;
	col += texture2D(u_texture, uv - dy) * 2.0 / 16.0;
	col += texture2D(u_texture, uv) * 4.0 / 16.0;
	col += texture2D(u_texture, uv + dy) * 2.0 / 16.0;
	col += texture2D(u_texture, uv + dx - dy) * 1.0 / 16.0;
	col += texture2D(u_texture, uv + dx) * 2.0 / 16.0;
	col += texture2D(u_texture, uv + dx + dy) * 1.0 / 16.0;
	return col;
}

vec4 gaussian_sample2(vec2 uv, vec2 dx, vec2 dy)
{
	float wet[7];
	wet[0] = 0.036;
	wet[1] = 0.113;
	wet[2] = 0.216;
	wet[3] = 0.269;
	wet[4] = 0.216;
	wet[5] = 0.113;
	wet[6] = 0.036;

	vec4 col = vec4(0.0);

	// 
	for (int i = 0; i < 7; i++) {
		// TvOďd݂|BŐ邽0.5
		col += texture2D(u_texture, uv + dy) * wet[i] * 0.5;
		// offsetTvO|Cg炷
		dy += 0.001;
	}

	// 
	for (int i = 0; i < 7; i++){
		col += texture2D(u_texture, uv + dx) * wet[i] * 0.5;
		dx += 0.001;
	}

	return col;
}

// 2xNgV[hƂ0~1̃_lԂ
float rand(vec2 co)
{
	return fract(sin(dot(co.xy, vec2(12.9898, 78.233))) * 43756.5453);
}

// easing
float ease_in_out_cubic(float x)
{
	return x < 0.5 ? 4.0 * x * x * x : 1.0 - pow(-2.0 * x + 2.0, 3.0) / 2.0;
}

// CRT1f̏㉺[ÂȂ錻ۂČ
float crt_ease(float x, float base, float offset)
{
	float tmp = mod(x + offset, 1.0);
	float xx = 1.0 - abs(tmp * 2.0 - 1.0);
	float ease = ease_in_out_cubic(xx);
	return ease * base + base * 0.8;
}

void main()
{
	vec4 c = vec4(0, 0, 0, 1);
	vec2 uv = v_texCoord;

	// uvʂoĂ悤ɂ䂪܂
	uv = distort(uv, 0.002);

	// uv͈͓oȂ΍hԂ
	if (uv.x < 0.0 || 1.0 < uv.x || uv.y < 0.0 || 1.0 < uv.y ) {
		gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
	}
	else {
		float floor_y = mod(v_texCoord.y * u_resolution.y / 3.0, 1.0);
		float isR = floor_y;
		float isG = floor_y;
		float isB = floor_y;

		vec2 dx = vec2(1.0 / u_resolution.x, 0.0);
		vec2 dy = vec2(0.0, 1.0 / u_resolution.y);

		uv += isR * -1.0 * dy;
		uv += isG * 0.0 * dy;
		uv += isB * 1.0 * dy;

		c = gaussian_sample2(uv, dx, dy);

		float floor_x = mod(uv.x * u_resolution.x / 5.0, 0.1);
		float ease_r = crt_ease(floor_x, c.r, 0.5);
		float ease_g = crt_ease(floor_x, c.g, 0.5);
		float ease_b = crt_ease(floor_x, c.b, 0.5);

		isR *= ease_r;
		isG *= ease_g;
		isB *= ease_b;

		isR += 0.2;
		isG += 0.2;
		isB += 0.2;

		gl_FragColor = vec4(isR, isG, isB, 1.0);
	}
}
